package me.Demon.BungeeWarpPro;

import com.google.common.io.ByteArrayDataOutput;
import me.Demon.BungeeWarpPro.atp.AtpCommand;
import me.Demon.BungeeWarpPro.libs.YamlConfig;
import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.api.plugin.Plugin;
import net.md_5.bungee.config.Configuration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class Main extends Plugin implements Listener {

    public static YamlConfig yamlConfig;
    public static Main plugin;
    private static Main instance;
    public static List<String> Bungee_Warp_List = new ArrayList<>();
    public HashMap<String, ByteArrayDataOutput> outputHashMap = new HashMap<>();

    @Override
    public void onEnable() {
        plugin = this;
        instance = this;
        yamlConfig = new YamlConfig("config.yml", plugin);
        yamlConfig.saveDefaultConfig();
        Configuration section = yamlConfig.getConfig().getSection("bungeewarp");
        if(section != null){
            Bungee_Warp_List.addAll(section.getKeys());
            for (String warp_name : Bungee_Warp_List) {
                System.out.print("# "+warp_name);
            }
        }
        getProxy().registerChannel("bungee:warp");
        getProxy().getPluginManager().registerListener(this,this);
        // 关于BC跨服Tpa
        getProxy().getPluginManager().registerCommand(this, new AtpCommand());
        ProxyServer.getInstance().registerChannel("bungee:atp");

    }
    public static Main getInstance(){
        return instance;
    }
}
