package me.Demon.BungeeWarpPro.atp;

import com.google.common.io.ByteArrayDataOutput;
import com.google.common.io.ByteStreams;
import java.util.function.Consumer;
import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.chat.ClickEvent.Action;
import net.md_5.bungee.api.config.ServerInfo;
import net.md_5.bungee.api.connection.ProxiedPlayer;

public class TpaUtil {

    public static void sendHelpMessage(ProxiedPlayer player) {
        player.sendMessage(new TextComponent("§7[§6战争领域§7] §f正确用法: §a/atp [玩家名]"));
    }

    public static void sendTargetMessage(ProxiedPlayer player, ProxiedPlayer target) {
        target.sendMessage(new TextComponent("§8§l[§e§l!§8§l] §7玩家 §6" + player.getName() + " §7正在向你发起传送请求."));
        TextComponent air = new TextComponent("     ");
        TextComponent acceptComponent = new TextComponent("§7[§a同意传送§7]");
        acceptComponent.setClickEvent(new ClickEvent(Action.RUN_COMMAND, "/atp accept"));
        acceptComponent.setHoverEvent(new HoverEvent(net.md_5.bungee.api.chat.HoverEvent.Action.SHOW_TEXT, new BaseComponent[]{new TextComponent("§e确认操作")}));
        TextComponent denyComponent = new TextComponent("§7[§c拒绝传送§7]");
        denyComponent.setClickEvent(new ClickEvent(Action.RUN_COMMAND, "/atp deny"));
        denyComponent.setHoverEvent(new HoverEvent(net.md_5.bungee.api.chat.HoverEvent.Action.SHOW_TEXT, new BaseComponent[]{new TextComponent("§e确认操作")}));
        air.addExtra(acceptComponent);
        air.addExtra("    ");
        air.addExtra(denyComponent);
        target.sendMessage(air);
    }

    public static void sendAcceptMessage(ProxiedPlayer player, ProxiedPlayer target) {
        player.sendMessage(new TextComponent("§8§l[§a§l!§8§l] §7玩家 §6" + target + " §7接受了你的传送请求"));
    }

    public static void sendDenyMessage(ProxiedPlayer player, ProxiedPlayer target) {
        player.sendMessage(new TextComponent("§8§l[§c§l!§8§l] §7玩家 §6" + target + " §7拒绝了你的传送请求"));
    }

    public static void sendMessageToServer(String channel, ServerInfo server, Consumer<ByteArrayDataOutput> consumer) {
        ByteArrayDataOutput dataOutput = ByteStreams.newDataOutput();
        dataOutput.writeUTF(channel);
        consumer.accept(dataOutput);
        server.sendData("bungee:atp", dataOutput.toByteArray());
    }
}
